

#include <SoftwareSerial.h>
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>

const char* ssid = "XXXXXX";         //Wifi network name
const char* password = "XXXXXX";     //Wifi password
WiFiServer ESPserver(80) ;
IPAddress ip(192, 168, 0, XXX);
IPAddress gateway(192, 168, 0, 254);
IPAddress subnet(255, 255, 255, 0);

String joystickX;
String joystickY;
String requestXX;
String requestYY;
String requestPP;
String requestTT;
unsigned char joystickXValue, joystickYValue;

SoftwareSerial Xbee(D5, D2); // RX, TX

//D5 noir/ D2 blanc/ rose: 5V /Vert:Ground


void sendToRanger(int joystickXValue, int joystickYValue, int panValue, int tiltValue) {


  Xbee.write(0xff); //new packet First bit
  //joystickXValue = joystickX.toInt();  ; //
  //joystickYValue = joystickY.toInt();  ; //
  Xbee.write(joystickXValue); //Second bit
  Xbee.write(joystickYValue);// third bit
  Xbee.write(panValue);   //(unused) fourth bit
  Xbee.write(tiltValue);   //(unused) fifht bit
  Xbee.write((unsigned char)0);   //(unused) sixth bit
  Xbee.write((unsigned char)0);   //(unused) seventh bit
  Xbee.write((unsigned char)(255 - (joystickXValue + joystickYValue + panValue + tiltValue) % 256)); //check value
  Serial.println("joystickXValue= " + joystickXValue);
  Serial.println("joystickYValue= " + joystickYValue);

  joystickXValue = 0;
  joystickYValue = 0;
}

void setup() {

  Xbee.begin(38400);
  Serial.begin(38400);
  WiFi.begin(ssid, password);
  WiFi.config(ip, gateway, subnet);
  Serial.println("");
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  while (WiFi.status() != WL_CONNECTED)
  {
    delay(100);
    Serial.print("*");
  }
  Serial.println("");
  Serial.println("WiFi connected");

  // Start the server
  ESPserver.begin();
  Serial.println("Server started");

  // Print the IP address
  Serial.print("The URL to control ESP8266: ");
  Serial.print("http://");
  Serial.print(WiFi.localIP());
}




void loop() {
  // Check if a client has connected
  WiFiClient client = ESPserver.available();
  if (!client)
  {
    return;
  }

  // Wait until the client sends some data
  Serial.println("New Client");
  while (!client.available())
  {
    delay(1);
  }

  // Read the first line of the request
  String request = client.readStringUntil('\r');
  Serial.println("request= " + request);
  client.flush();

  // Match the request


  if (request.startsWith("GET /joystickX=") == 1)
  {
    Serial.println("Request X/Y activated");


    String requestX = request;
    String requestY = request;

    int s = requestX.indexOf("X");  //find location in string
    //Serial.println("int s= " + s);

    int e = requestX.indexOf("&");  //extract the info
    //Serial.println("int e= " + e);

    String requestXX = requestX.substring(s + 2, e);
    //requestX.replace("=","");
    //Serial.println("requestX= " + requestXX);

    int ss = requestY.indexOf("Y", e); //find location in string
    int ee = requestY.indexOf("&", ss); //extract the info
    String requestYY = requestY.substring(ss + 2, ee);
    //requestY.substring(:,&);
    Serial.println("requestY= " + requestYY);
    Serial.println("requestX= " + requestXX);
    sendToRanger(requestXX.toInt(), requestYY.toInt(), requestPP.toInt(), requestTT.toInt());

  }

  if (request.startsWith("GET /joystickP=") == 1)
  {
    Serial.println("Request P/T activated");

    String requestP = request;
    String requestT = request;

    int s = requestP.indexOf("P");  //find location in string

    int e = requestP.indexOf("&");  //extract the info

    String requestPP = requestP.substring(s + 2, e);

    int ss = requestT.indexOf("T", e); //find location in string
    int ee = requestT.indexOf("&", ss); //extract the info
    String requestTT = requestT.substring(ss + 2, ee);

    requestT.replace(":", "");
    Serial.println("requestP= " + requestPP);
    Serial.println("requestT= " + requestTT);
    sendToRanger(requestXX.toInt(), requestYY.toInt(), requestPP.toInt(), requestTT.toInt());

  }
  Serial.println("requestX= " + requestXX);
  Serial.println("requestY= " + requestYY);
  Serial.println("requestP= " + requestPP);
  Serial.println("requestT= " + requestTT);


  delay(10);




  delay(1);
  client.stop();
  Serial.println("Client disconnected");
  Serial.println("");



}
